""" core exception package"""
from .base import (
    CustomException,
    BadRequestException,
    NotFoundException,
    ForbiddenException,
    UnprocessableEntity,
    DuplicateValueException,
    UnauthorizedException,
    NotImplementException,
)
from .token import DecodeTokenException, ExpiredTokenException
from .user import (
    PasswordDoesNotMatchException,
    DuplicateEmailOrNicknameException,
    UserNotFoundException,
)


__all__ = [
    "CustomException",
    "BadRequestException",
    "NotFoundException",
    "ForbiddenException",
    "UnprocessableEntity",
    "DuplicateValueException",
    "UnauthorizedException",
    "DecodeTokenException",
    "ExpiredTokenException",
    "PasswordDoesNotMatchException",
    "DuplicateEmailOrNicknameException",
    "UserNotFoundException",
]
